
/* ----------------------------------------------- */
/* ruin21.c					   */
/* ----------------------------------------------- */
/* program for squl option 'd'			   */
/* display de Bruijn diagram - 1st, 2nd, & 3rd gen */
/* Harold V. McIntosh, 20 February 1988		   */
/* 21 February 1988 - add j0=i0; to Pass 4's	   */
/* 12 August 1988 - adaptation for squl.c	   */
/* 6 June 1992 - adapted to CAMEX		   */
/* ----------------------------------------------- */

# include "camex.h"
# include "keybrd.h"
# include <stdio.h>

# define  QL   48  /* dim arry for sample (even)	*/
# define  NK   64  /* node count = KK^6			*/
# define  XC    6  /* maximum cycle length		*/
# define AUR  148  /* matrix u.l. row (from bottom)	*/
# define AUC   20  /* matrix u.l. col (graf)		*/
# define HER    3  /* header u.l. row			*/
# define HEC   14  /* header u.l. col			*/
# define PER    4  /* help   u.l. row			*/
# define PEC   25  /* help   u.l. col			*/
# define TMR    6  /* matrix u.l. row (text)		*/
# define TMC    2  /* matrix u.l. col			*/
# define TTR    6  /* table u.l. row (text)		*/
# define TTC   20  /* table u.l. col			*/

extern char mogrul[];		/* general Moore rule (2,1)	 */
extern char moarul[];		/* general Moore auxiliary (2,1) */
extern int  no, lk;		/* # nodes, links 		 */

extern FILE *P0;

/* edit the de Bruijn diagram */
edijn() {
int  aa[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
int  bb[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
int  dk;		/* write matrix on disk	      */
char cc[QL][QL];	/* cell array for editor      */
char c;

grfmode();
dk=0;
clijn();
videocursor(0,0,5); tidat();
videocursor(0,23,0); printf("%8u",coreleft());

  while (0<1) {
  videocursor(0,0,0); videoputc('d',1);
  videocursor(0,0,2); videoputc('?',2);
  c=kbdin();
  if (c=='\015') break;
  videocursor(0,0,1); videoputc(c,2);
  videocursor(0,0,2); videoputc(' ',2);
  videocursor(0,0,5); tidat();
  videocursor(0,HER,0);
  switch (c) {

  case   DEL:  fplane(0xf,0); break;	/*  DELETE - clear all planes	*/

    case 'a': scrstr("still life:  "); pass1(aa,0); mcopy(bb,aa); break;
    case 'b': scrstr("longitudinal:"); pass1(aa,1); mcopy(bb,aa); break;
    case 'c': scrstr("diagonal:    "); pass1(aa,2); mcopy(bb,aa); break;
    case 'd': scrstr("transversal: "); pass1(aa,3); mcopy(bb,aa); break;
    case 'e': scrstr("zeroes:      "); pass1(aa,4); mcopy(bb,aa); break;
    case 'f': scrstr("ones:        "); pass1(aa,5); mcopy(bb,aa); break;

    case 'i': cledi('m'); prng(1); break;
    case 'k': dk=1; break;
    case 'K': dk=0; break;
    case 'm': cledi('m'); prnz(aa,0); prnd(aa); break;
    case 'n': cledi('m'); prnz(bb,0); prnd(bb); break;
    case 'o': cledi('m'); prnz(bb,-1); break;
    case 't': cledi('m'); strp(aa,bb); break;
    case 'z': cledi('m'); break;
    case 'Z': cledi('x'); break;
    case '8': eipo(aa,bb); break;

    case '=': videocursor(0,5,0); pass4(aa); break;
    case '~': nomar(bb); mcopy(aa,bb); break;

    case '1': filp(bb,cc,1); cfilp(bb,1); break;
    case '2': filp(bb,cc,2); cfilp(bb,2); break;
    case '3': filp(bb,cc,3); cfilp(bb,3); break;
    case '4': filp(bb,cc,4); cfilp(bb,4); break;
    case '5': filp(bb,cc,5); cfilp(bb,5); break;
    case '6': filp(bb,cc,6); cfilp(bb,6); break;

    case 'g': dbonegen(cc); frayme(); screen(cc); break;
    case 'G':
	 frayme();
	 while (!kbdst()) {dbonegen(cc); screen(cc);} 
	 kbdin();
	 break;
    case 's': sstep(); break;			/* single step of evolution */
    case 'S': gogo(); break;			/* generations of evolution */

    case 'A': pass7(aa,bb,1,1,dk); break;
    case 'B': pass7(aa,bb,2,1,dk); break;
    case 'C': pass7(aa,bb,3,1,dk); break;
    case 'D': pass7(aa,bb,4,1,dk); break;
    case 'E': pass7(aa,bb,5,1,dk); break;
    case 'F': pass7(aa,bb,6,1,dk); break;

    case 'H':pass7(aa,bb,numin(0),1,dk); break;

    case 'M': pass7(aa,bb,1,0,dk); break;
    case 'N': pass7(aa,bb,2,0,dk); break;
    case 'O': pass7(aa,bb,3,0,dk); break;
    case 'P': pass7(aa,bb,4,0,dk); break;
    case 'Q': pass7(aa,bb,5,0,dk); break;
    case 'R': pass7(aa,bb,6,0,dk); break;

    case 'T': pass7(aa,bb,1,2,dk); break;
    case 'U': pass7(aa,bb,2,2,dk); break;
    case 'V': pass7(aa,bb,3,2,dk); break;
    case 'W': pass7(aa,bb,4,2,dk); break;
    case 'X': pass7(aa,bb,5,2,dk); break;
    case 'Y': pass7(aa,bb,6,2,dk); break;

    case 'u': pass7(aa,bb,numin(0),0,dk); break;
    case 'v': cmfilp(bb,numin(0)); break;

    case '?': case '/': cledi('h'); clijn(); break;

    default: break;
    }	/* end switch */
  }	/* end while  */
txtmode();
}	/* end edijn */

/* edijn help menu */

char eimenu[][DCH] = {
  "abcdef-shifts",
  "ABCDEF-strips",
  "MNOPQR-0,0's ",
  "123456-sample",
  "SsGg-run     ",
  "=-type matrix",
  "i-matrix grid",
  "m-grph matrix",
  "t-mtrx power ",
  "8-survey 1-9 ",
  "/,z-clr scrn ",
  "Z-clear all  ",
  "DEL - cl CAM ",
  "<cr> - exit  ",
  };

/* display edijn menu */
clijn() {gdmenu(eimenu,14);}

/* generic help panel - graphics mode, upper right panel */
gdmenu(menu,n) char menu[][DCH]; int n; {int i;
for (i=0; i<n; i++) {videocursor(0,PER+i,PEC); printf(&menu[i][0]);}
videocursor(0,0,2);
}

/* clear individual panels */
cledi(c) char c; {switch (c) {
  case 'h': videoscroll(PER,PEC,24,39,0,0); break;   /* help panel   */
  case 'm': videoscroll(TMR,TMC,24,24,0,0); break;   /* matrix panel */
  case 't': videoscroll(TTR-2,TTC,24,39,0,0); break; /* table panel  */
  case 'x': videoscroll(1,0,24,39,0,0); break;       /* most  screen */
  case 'X': videoscroll(0,0,24,39,0,0); break;       /* whole screen */
  default: break;}}

/* THREE31.C */

/* ---------------------------------------------------- */
/* Pass 1 marks sequences conforming to some shift      */
/* ---------------------------------------------------- */
/*  a0 = c0  						*/
/*  a1 = c1  		 a5 p1 a4     i0 i3 i6		*/
/*  a2 = se0 	plane 0	 a7 a0 a6  =  i1 i4 i7		*/
/*  a3 = sw0 		 a3 p0 a2     i2 i5 i8		*/
/*  a4 = ne0 						*/
/* ---------------------------------------------------- */

pass1(z,l) int z[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK]; int l; {
int  a0, a2, a3, a4, a5, a6, a7, p0, p1;
int  k, m;
cledi('m');
zerar(z,0);
for (a0=0; a0<KK; a0++)
for (a2=0; a2<KK; a2++)
for (a3=0; a3<KK; a3++)
for (a4=0; a4<KK; a4++)
for (a5=0; a5<KK; a5++)
for (a6=0; a6<KK; a6++)
for (a7=0; a7<KK; a7++)
for (p0=0; p0<KK; p0++)
for (p1=0; p1<KK; p1++) {
  k=mogrul[nineq(a0,a2,a3,a4,a5,a6,a7,p0,p1)];
  switch (l) {
    case 0: m=a0; break;	/* still life   */
    case 1: m=a7; break;	/* longitudinal */
    case 2: m=a3; break;	/* diagonal	*/
    case 3: m=p0; break;	/* transversal	*/
    case 4: m=0;  break;	/* zeroes	*/
    case 5: m=1;  break;	/* ones		*/
    default: break;}
  z[a5][a7][a3][p1][a0][p0][p1][a0][p0][a4][a6][a2]=(k==m?1:0);
  adot(bdex(p1,a0,p0,a4,a6,a2),bdex(a5,a7,a3,p1,a0,p0),(k==m?1:2));
  }
}

/* turn binary index into a coordinate */
int bdex(i0,i1,i2,i3,i4,i5) int i0, i1, i2, i3, i4, i5; {
return i0+KK*(i1+KK*(i2+KK*(i3+KK*(i4+KK*i5))));
}

/* turn three binary digits into a decimal number */
int tdex(i0,i1,i2) int i0, i1, i2; {return i0+KK*(i1+KK*i2);}

/* pass 4 - print the matrix elements of the connection matrix */
pass4(z) int z[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK]; {
int  i0, i1, i2, i3, i4, i5, i6, i7, i8, tdex();
P0=fopen("RUIN21.DAT","wt");
for (i2=0; i2<KK; i2++)
for (i1=0; i1<KK; i1++)
for (i0=0; i0<KK; i0++)
for (i5=0; i5<KK; i5++)
for (i4=0; i4<KK; i4++)
for (i3=0; i3<KK; i3++) {
  for (i8=0; i8<KK; i8++)
  for (i7=0; i7<KK; i7++)
  for (i6=0; i6<KK; i6++)
    if (z[i0][i1][i2][i3][i4][i5][i3][i4][i5][i6][i7][i8]!=0) 
      fprintf(P0,"%1d%1d%1d, ",tdex(i0,i1,i2),tdex(i3,i4,i5),tdex(i6,i7,i8));
  fprintf(P0,"\n");
  }
fclose(P0);
}

/*------------------------------------------*/
/* pass 7 - get the loops of length l       */
/*------------------------------------------*/
/*  t - 0 = isolated (0,0); 1 = cyclic      */
/*  t - 2 = Escher (Dirac)		    */
/* dk - 0 = normal, 1 = write links on disk */
/*  z - array of links	(data) KK^6xKK^6    */
/*  w - array of nodes (output data)        */
/* oc - feasible links 2d stage KK^lxKK^l   */
/*------------------------------------------*/

pass7(z,w,l,t,dk)
int *z, *w, l, t, dk; {
  int  f, g, k, p, q;
  char oc[NK][NK];	/* node count */
cledi('h');
videocursor(0,HER,HEC); printf("width %1d.",l);
videocursor(0,HER,HEC+11); printf("gen nodes links");
for (p=0; p<NK; p++) for (q=0; q<NK; q++) oc[p][q]=4;
k=0;
do {
  g=0; k++; no=0; lk=0;
  cledi('m');
  pass7x(z,w,oc,l,0,t);
  for (p=0; p<NK; p++) for (q=0; q<NK; q++) {
    f=oc[p][q];
    if (f==7) no++;
    if (f==5||f==6) g=1;
    oc[p][q]=(f==7?4:0);
    }
    videocursor(0,PER-1+k%16,PEC); printf("%3d %5d %5d",k,no,lk);
  } while (g==1);
videocursor(0,23,0);
if (dk==1) {
  P0=fopen("P0.DAT","wt");
  pass7x(z,w,oc,l,3,t);
  fclose(P0);
  }
if (no<NK) {
  g=4;
  for (p=0; p<NK; p++) for (q=0; q<NK; q++) oc[p][q]=(oc[p][q]==4)?g++:0;
  zerar(w,-1);
  cledi('m');
  prng(1);
  pass7x(z,w,oc,l,1,t);
  return;
  }
if (no<2*NK) {
  g=4;
  for (p=0; p<NK; p++) for (q=0; q<NK; q++) oc[p][q]=(oc[p][q]==4)?g++:0;
  cledi('m');
  pass7x(z,w,oc,l,2,t);
  return;
  }
}

/* pass 7x - display the acceptable strings of length l */
/* t=0 - isolated (0,0); t=1 - cyclic, try all		*/
/* t=2 - Escher type, zeroes on left, ones on right	*/
/* r[3][12] - build second stage partial neighborhoods	*/

pass7x(z,w,oc,l,s,t) char *oc; int  *z, *w, l, s, t; {
int i[6], j[6], r[3][12];
int p, i0, i1, i2, i3, i4, i5;
if (l<1) return;
switch (t) {
  case 0:
    if (l>12) return;
    for (p=0; p<6; p++) i[p]=0;
    for (p=0; p<6; p++) j[p]=0;
    pass7a(z,oc,r,w,i,j,0,l,s);
    break;
  case 1:
    if (l>12) return;
    for (i0=0; i0<KK; i0++) {i[0]=i0;
    for (i1=0; i1<KK; i1++) {i[1]=i1;
    for (i2=0; i2<KK; i2++) {i[2]=i2;
    for (i3=0; i3<KK; i3++) {i[3]=i3;
    for (i4=0; i4<KK; i4++) {i[4]=i4;
    for (i5=0; i5<KK; i5++) {i[5]=i5;
      j[0]=i0; j[1]=i1; j[2]=i2; j[3]=i3; j[4]=i4; j[5]=i5;
      pass7a(z,oc,r,w,i,j,0,l,s);
      }}}}}}
    break;
  case 2:
    if (l>12) return;
    for (p=0; p<6; p++) i[p]=1;
    for (p=0; p<6; p++) j[p]=0;
    pass7a(z,oc,r,w,i,j,0,l,s);
    break;
  default: break;}
}

/* pass 7a - recursive step in pass 7, strip width l	*/
/* i[6] = left p.n., j[6] = right p.n., k = len 2d.s.pn */
/* s=0 - matrix panel 	 s=1 - panel and ww (=bb)	*/
/* s=2 - no panel & ww	 s=3 - print the link when done	*/

pass7a(zz,oc,r,ww,i,j,k,l,s)
  int  *i, *j, k, l, s;
  int  r[3][12];
  int  ww[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
  int  zz[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
  char oc[NK][NK];
  {
int p, w, x, y, i0, i1, i2;
int jj0, jj1, jj2, jj3, jj4, jj5;
int p0, p1, p2, p3, p4, p5;
int q0, q1, q2, q3, q4, q5;
if (k<l) {
  jj0=j[0]; jj1=j[1]; jj2=j[2]; jj3=j[3]; jj4=j[4]; jj5=j[5];
  for (i0=0; i0<KK; i0++) {r[0][k]=i0;
  for (i1=0; i1<KK; i1++) {r[1][k]=i1;
  for (i2=0; i2<KK; i2++) {r[2][k]=i2;
    if (zz[jj0][jj1][jj2][jj3][jj4][jj5][jj3][jj4][jj5][i0][i1][i2]!=0) {
      j[0]=jj3; j[1]=jj4; j[2]=jj5; j[3]=i0; j[4]=i1; j[5]=i2;
      pass7a(zz,oc,r,ww,i,j,k+1,l,s);}
    }}}
  return;}
for (p=0; p<6; p++) if (i[p]!=j[p]) return;
for (p=0, w=0; p<l; p++) w=w*KK+r[0][p];
for (p=0, x=0; p<l; p++) x=x*KK+r[1][p];
for (p=0, y=0; p<l; p++) y=y*KK+r[2][p];
if ((oc[w][x]>=4)&&(oc[x][y]>=4)) {
  switch (s) {
    case 0:			/* points in console matrix	    */
      adot(2*w,2*x,1); adot(2*w+1,2*x+1,1); oc[w][x]|=1;
      adot(2*x+1,2*y,2); adot(2*x,2*y+1,2); oc[x][y]|=2;
      lk++; break;
    case 1:			/* consolidated connectivity matrix */
      p5=oc[w][x]-4;
      q5=oc[x][y]-4;
      adot(2*q5,2*p5,3); adot(2*q5+1,2*p5+1,3);
      adot(2*q5+1,2*p5,3); adot(2*q5,2*p5+1,3);
      p0=p5%KK; p5/=KK;
      p1=p5%KK; p5/=KK;
      p2=p5%KK; p5/=KK;
      p3=p5%KK; p5/=KK;
      p4=p5%KK; p5/=KK;
      q0=q5%KK; q5/=KK;
      q1=q5%KK; q5/=KK;
      q2=q5%KK; q5/=KK;
      q3=q5%KK; q5/=KK;
      q4=q5%KK; q5/=KK;
      ww[p0][p1][p2][p3][p4][p5][q0][q1][q2][q3][q4][q5]=w+NK*x;
      break;
    case 2:			/* compact matrix on screen	    */
      p5=oc[w][x]-4;
      q5=oc[x][y]-4;
      adot(p5,q5,3);
      break;
    case 3:			/* write linkages to disk file	    */
      fprintf(P0," ");
      if (l>1) for (p=0; p<l-1; p+=2)
        fprintf(P0,"%1.1X",((r[0][p]*KK+r[1][p])*KK+r[0][p+1])*KK+r[1][p+1]);
      if (l%2==1) fprintf(P0,"%1.1X",r[0][l-1]*KK+r[1][l-1]); fprintf(P0," ");
      if (l>1) for (p=0; p<l-1; p+=2)
	fprintf(P0,"%1.1X",((r[1][p]*KK+r[2][p])*KK+r[1][p+1])*KK+r[2][p+1]);
      if (l%2==1) fprintf(P0,"%1.1X",r[1][l-1]*KK+r[2][l-1]); fprintf(P0," - ");
      for (p=0; p<l; p++) fprintf(P0,"%1.1d",r[0][p]); fprintf(P0," ");
      for (p=0; p<l; p++) fprintf(P0,"%1.1d",r[1][p]); fprintf(P0," ");
      for (p=0; p<l; p++) fprintf(P0,"%1.1d",r[2][p]); fprintf(P0,"\n");
      break;
    default: break;}
  }
}

/* frame the screen of evolution */
frayme() {int i0;
  for (i0=0; i0<QL+2; i0++) {
    bbdot(i0,0,3);
    bbdot(0,i0,3);
    bbdot(i0,QL+1,3);
    bbdot(QL+1,i0,3);
    }
}

/* display a screen of evolution */
screen(z) char z[QL][QL]; {int i0, i1;
  for (i0=0; i0<QL; i0++)
  for (i1=0; i1<QL; i1++)
    aadot(i0+1,i1+1,(z[i0][i1]==0)?0:1);
}

/* adot(i,j,l) - place dot on automaton screen at (i,j) in color l */
adot(i,j,l) int i, j, l; {
  j=(AUR+j)%AUR; i=(AUR+i)%AUR;
  videodot(199-(AUR-i),AUC+j,l);
}

/* plot a big square to represent a matrix element */
aadot(i,j,l) int i, j, l; {
adot(2*i,2*j,l);
adot(2*i+1,2*j,l);
adot(2*i,2*j+1,l);
adot(2*i+1,2*j+1,l);
}

/* plot a faint square to represent a matrix element */
bbdot(i,j,l) int i, j, l; {
adot(2*i,2*j,0);
adot(2*i+1,2*j,0);
adot(2*i,2*j+1,0);
adot(2*i+1,2*j+1,l);
}

/* multiply two matrices      */
/* result may overwrite first */
/* factor but not the second  */
mprod(z,x,y)
int x[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
int y[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
int z[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
{
int i0, i1, i2, i3, i4, i5;
int j0, j1, j2, j3, j4, j5;
int k0, k1, k2, k3, k4, k5;
int w[KK][KK][KK][KK][KK][KK];

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++) {

  for (j0=0; j0<KK; j0++)
  for (j1=0; j1<KK; j1++)
  for (j2=0; j2<KK; j2++)
  for (j3=0; j3<KK; j3++)
  for (j4=0; j4<KK; j4++)
  for (j5=0; j5<KK; j5++) {

    w[j0][j1][j2][j3][j4][j5]=0; 

    for (k0=0; k0<KK; k0++)
    for (k1=0; k1<KK; k1++)
    for (k2=0; k2<KK; k2++)
    for (k3=0; k3<KK; k3++)
    for (k4=0; k4<KK; k4++)
    for (k5=0; k5<KK; k5++)

      w[j0][j1][j2][j3][j4][j5]+= 
      x[i0][i1][i2][i3][i4][i5][k0][k1][k2][k3][k4][k5]*
      y[k0][k1][k2][k3][k4][k5][j0][j1][j2][j3][j4][j5];

    }

  for (k0=0; k0<KK; k0++)
  for (k1=0; k1<KK; k1++)
  for (k2=0; k2<KK; k2++)
  for (k3=0; k3<KK; k3++)
  for (k4=0; k4<KK; k4++)
  for (k5=0; k5<KK; k5++)

    z[i0][i1][i2][i3][i4][i5][k0][k1][k2][k3][k4][k5]=
    w[k0][k1][k2][k3][k4][k5];

  }
 
}

/* normalize an array			*/
/* which means, replace -1's by zeroes  */
/* and the others by ones		*/
nomar(z)int z[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK]; {
int i0, i1, i2, i3, i4, i5;
int j0, j1, j2, j3, j4, j5;
int s;

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)

  for (j0=0; j0<KK; j0++)
  for (j1=0; j1<KK; j1++)
  for (j2=0; j2<KK; j2++)
  for (j3=0; j3<KK; j3++)
  for (j4=0; j4<KK; j4++)
  for (j5=0; j5<KK; j5++) {

    s=z[i0][i1][i2][i3][i4][i5][j0][j1][j2][j3][j4][j5];
    z[i0][i1][i2][i3][i4][i5][j0][j1][j2][j3][j4][j5]=(s==-1)?0:1;

    }

}

/* fill an array with a constant */
zerar(z,c)
int z[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
int c;
{
int i0, i1, i2, i3, i4, i5;
int j0, j1, j2, j3, j4, j5;

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)

  for (j0=0; j0<KK; j0++)
  for (j1=0; j1<KK; j1++)
  for (j2=0; j2<KK; j2++)
  for (j3=0; j3<KK; j3++)
  for (j4=0; j4<KK; j4++)
  for (j5=0; j5<KK; j5++)

    z[i0][i1][i2][i3][i4][i5][j0][j1][j2][j3][j4][j5]=c;

}

/* copy one array to another */
mcopy(z,x)
int z[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
int x[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
{
int i0, i1, i2, i3, i4, i5;
int j0, j1, j2, j3, j4, j5;

for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)

  for (j0=0; j0<KK; j0++)
  for (j1=0; j1<KK; j1++)
  for (j2=0; j2<KK; j2++)
  for (j3=0; j3<KK; j3++)
  for (j4=0; j4<KK; j4++)
  for (j5=0; j5<KK; j5++)

    z[i0][i1][i2][i3][i4][i5][j0][j1][j2][j3][j4][j5]=
    x[i0][i1][i2][i3][i4][i5][j0][j1][j2][j3][j4][j5];

}

/* show the array z as a set of dots on the videoscreen */
prnz(z,l) int z[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK], l; {
int i0, i1, i2, i3, i4, i5;
int j0, j1, j2, j3, j4, j5;
int i, j, k;
for (i2=0; i2<KK; i2++)
for (i1=0; i1<KK; i1++)
for (i0=0; i0<KK; i0++)
for (i5=0; i5<KK; i5++)
for (i4=0; i4<KK; i4++)
for (i3=0; i3<KK; i3++)
  for (j2=0; j2<KK; j2++)
  for (j1=0; j1<KK; j1++)
  for (j0=0; j0<KK; j0++)
  for (j5=0; j5<KK; j5++)
  for (j4=0; j4<KK; j4++)
  for (j3=0; j3<KK; j3++) {
    i=bdex(j0,j1,j2,j3,j4,j5);
    j=bdex(i0,i1,i2,i3,i4,i5);
    k=z[i0][i1][i2][i3][i4][i5][j0][j1][j2][j3][j4][j5];
    if (l==0)  if (k==0)  bbdot(i,j,1); else aadot(i,j,3);
    if (l==-1) if (k==-1) bbdot(i,j,1); else aadot(i,j,3);
    }
}

/* show the outline of the array z as dots on the videoscreen */
prng(l) int l;{
int i0, i1, i2, i3, i4, i5;
int j0, j1, j2, j3, j4, j5;
int i, j;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
  for (j0=0; j0<KK; j0++)
  for (j1=0; j1<KK; j1++)
  for (j2=0; j2<KK; j2++)
  for (j3=0; j3<KK; j3++)
  for (j4=0; j4<KK; j4++)
  for (j5=0; j5<KK; j5++) {
    i=bdex(j0,j1,j2,j3,j4,j5);
    j=bdex(i0,i1,i2,i3,i4,i5);
    adot(2*i,2*j,l);
    }
}

/* calculate the 0,0 element of z */
int zzel(z) int z[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK]; {
return z[0][0][0][0][0][0][0][0][0][0][0][0];
}

/* calculate the trace of z */
long int traz(z) int z[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK]; {
int i0, i1, i2, i3, i4, i5;
long int k;
k=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
  k+=z[i0][i1][i2][i3][i4][i5][i0][i1][i2][i3][i4][i5];
return k;
}

/* print the diagonal of the array z */
prnd(z) int z[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK]; {
int i, j, k, l, i0, i1, i2, i3, i4, i5;
int zzel();
l=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++) {
    i=bdex(i0,i1,i2,i3,i4,i5);
    k=z[i0][i1][i2][i3][i4][i5][i0][i1][i2][i3][i4][i5];
    l+=k;
    j=(k==0?1:3);
    aadot(i,i,j);
  }
  videocursor(0,1,10);  printf("00:%6u",zzel(z));
  videocursor(0,1,20); printf("Tr:%6u",l);
}

/* bb becomes next power, display matrix and diagonal */
strp(aa,bb) int *aa, *bb; {mprod(bb,bb,aa); prnz(bb,0); prnd(bb);}

/* calculate traces and (0,0) elements for first 9 powers of aa */
eipo(aa,bb) int *aa, *bb; {
int  i, zzel();
long int traz();
cledi('t');
videocursor(0,TTR-2,TTC); printf("isolated cyclic");
videocursor(0,TTR,TTC); printf("%6u",zzel(aa)); printf(",%8lu",traz(aa));
for (i=0; i<8; i++) {
  mprod(bb,bb,aa);
  videocursor(0,TTR+1+i,TTC); printf("%6u",zzel(bb)); printf(",%8lu",traz(bb));
  }
}

/* fill the field with a configuration of periodicity obtained	*/
/* with the help of a de Bruijn diagram.			*/
/* bb is a connectivity matrix with FF's and coded nodes	*/
/* cc is an array for the sample configuration			*/
/* if (n==0) {screen(cc); printf("%3d",i); return;}		*/

filp(bb,cc,l) int *bb; char cc[QL][QL]; int l; {
int x[12*NK], y[NK], z[XC];
int i0, j0, i, j, k, m, n;
cledi('m');
lnze(x,&n,bb);
videocursor(0,1,34); printf("%5d",n);
if (n==0) return;
i=rand()%n; m=x[i]; i0=m/NK; j0=m%NK; m=bb[m]; 
ecox(z,m%NK,l); for (k=0; k<QL; k++) cc[QL/2][k]=z[k%l];
ecox(z,m/NK,l); for (k=0; k<QL; k++) cc[QL/2+1][k]=z[k%l];
i=j0;
for (j=QL/2+2; j<QL; j++) {
  lnzr(y,&n,bb,i);
  videocursor(0,1,28); printf("%5d",n);
  i=rand()%n; i=y[i]; m=bb[i]/NK; i%=NK;
  ecox(z,m,l); for (k=0; k<QL; k++) cc[j][k]=z[k%l];
  }
i=i0;
for (j=QL/2-1; j>=0; j--) {
  lnzc(y,&n,bb,i);
  videocursor(0,1,28); printf("%5d",n);
  i=rand()%n; i=y[i]; m=bb[i]%NK; i/=NK;
  ecox(z,m,l); for (k=0; k<QL; k++) cc[j][k]=z[k%l];
  }
frayme();
screen(cc);
}

/* locate and count the nonzero elements of the rth row of bb */
lnzr(x,n,bb,r)  int bb[NK][NK]; int x[NK]; int *n, r; {int i, m;
for (i=0, m=0; i<NK; i++) if (bb[r][i]!=-1) {x[m]=i+r*NK; m++;} 
*n=m;}

/* locate and count the nonzero elements of a column of bb */
lnzc(x,n,bb,c)  int bb[NK][NK]; int x[NK]; int *n, c; {int i, m;
for (i=0, m=0; i<NK; i++) if (bb[i][c]!=-1) {x[m]=c+i*NK; m++;}
*n=m;}

/* locate and count the nonzero elements within the matrix bb */
lnze(x,n,bb)  int bb[NK][NK]; int x[12*NK]; int *n; {int i, j, m;
m=0; for (i=0; i<NK; i++) for (j=0; j<NK; j++) 
  if (bb[i][j]!=-1) {x[m]=j+i*NK; m++;
     if (m>=12*NK) {*n=m-1; printf("$"); return;}}
*n=m;}

/* decompose an index n into a series of l cell values */
ecox(x,n,l) int x[XC]; int n, l; {int i;
for (i=0; i<l; i++, n/=KK) x[l-i-1]=n%KK;}

/* fill CAM bitplane 0 with a configuration whose periodicity */
/* has been obtained from a de Bruijn diagram.		      */
/* bb is a connectivity matrix with FF's and coded nodes      */
/* cc is an array for the sample configuration		      */
/* l is the length of the vertical strip to be inserted       */

cfilp(bb,l) int *bb; int l; {
char cc[CL];
int  x[12*NK], y[NK], z[XC];
int  i0, j0, i, j, k, m, n;
wait();
pnotv();
lnze(x,&n,bb);
videocursor(0,1,34); printf("%5d",n);
if (n==0) return;
i=rand()%n; m=x[i]; i0=m/NK; j0=m%NK; m=bb[m]; 
ecox(z,m%NK,l); for (k=0; k<CL; k++) cc[k]=z[k%l]; writrow(cc,CL/2,0x01);
ecox(z,m/NK,l); for (k=0; k<CL; k++) cc[k]=z[k%l]; writrow(cc,CL/2-1,0x01);
i=j0;
for (j=CL/2-2; j>=0; j--) {
  lnzr(y,&n,bb,i);
  videocursor(0,1,28); printf("%5d",n);
  i=rand()%n; i=y[i]; m=bb[i]/NK; i%=NK;
  ecox(z,m,l); for (k=0; k<CL; k++) cc[k]=z[k%l]; writrow(cc,j,0x01);
  }
i=i0;
for (j=CL/2+1; j<CL; j++) {
  lnzc(y,&n,bb,i);
  videocursor(0,1,28); printf("%5d",n);
  i=rand()%n; i=y[i]; m=bb[i]%NK; i/=NK;
  ecox(z,m,l); for (k=0; k<CL; k++) cc[k]=z[k%l]; writrow(cc,j,0x01);
  }
gotv();
}

/* cfillp modified to insert a left margin for each column */

cmfilp(bb,l) int *bb; int l; {
char cc[CL];
int  x[12*NK], y[NK], z[XC];
int  i0, j0, i, j, k, m, n;
wait();
pnotv();
lnze(x,&n,bb);
videocursor(0,1,34); printf("%5d",n);
if (n==0) return;
i=rand()%n; m=x[i]; i0=m/NK; j0=m%NK; m=bb[m]; 
ecox(z,m%NK,l);
for (k=0; k<100; k++) cc[k]=0;
for (k=100; k<100+l; k++) cc[k]=z[k-100];
for (k=100+l; k<CL; k++) cc[k]=1;
writrow(cc,CL/2,0x01);
ecox(z,m/NK,l);
for (k=0; k<100; k++) cc[k]=0;
for (k=100; k<100+l; k++) cc[k]=z[k-100];
for (k=100+l; k<CL; k++) cc[k]=1;
writrow(cc,CL/2-1,0x01);
i=j0;
for (j=CL/2-2; j>=0; j--) {
  lnzr(y,&n,bb,i);
  videocursor(0,1,28); printf("%5d",n);
  i=rand()%n; i=y[i]; m=bb[i]/NK; i%=NK;
  ecox(z,m,l);
for (k=0; k<100; k++) cc[k]=0;
for (k=0; k<l; k++) cc[100+k]=z[k];
for (k=100+l; k<CL; k++) cc[k]=1;
writrow(cc,j,0x01);
  }
i=i0;
for (j=CL/2+1; j<CL; j++) {
  lnzc(y,&n,bb,i);
  videocursor(0,1,28); printf("%5d",n);
  i=rand()%n; i=y[i]; m=bb[i]%NK; i/=NK;
  ecox(z,m,l);
for (k=0; k<100; k++) cc[k]=0;
for (k=0; k<l; k++) cc[100+k]=z[k];
for (k=100+l; k<CL; k++) cc[k]=1;
writrow(cc,j,0x01);
  }
gotv();
}

/* -------------------------------------------------------------------- */

/* calculate one generation of evolution */
/* of (2,1) Moore automaton for ruin21	 */
dbonegen(a) char a[QL][QL]; {
char b[QL][QL];
int  a0, a2, a3, a4, a5, a6, a7, p0, p1;
int  i0, i1;
  for (i0=0; i0<QL; i0++)
  for (i1=0; i1<QL; i1++) {
    a0=a[i0][i1];
    a2=a[(QL+i0+1)%QL][(QL+i1+1)%QL];
    a3=a[(QL+i0-1)%QL][(QL+i1+1)%QL];
    a4=a[(QL+i0+1)%QL][(QL+i1-1)%QL];
    a5=a[(QL+i0-1)%QL][(QL+i1-1)%QL];
    a6=a[(QL+i0+1)%QL][i1];
    a7=a[(QL+i0-1)%QL][i1];
    p0=a[i0][(QL+i1+1)%QL];
    p1=a[i0][(QL+i1-1)%QL];
    b[i0][i1]=mogrul[nineq(a0,a2,a3,a4,a5,a6,a7,p0,p1)];
    }
  for (i0=0; i0<QL; i0++)
  for (i1=0; i1<QL; i1++) a[i0][i1]=b[i0][i1];
}

/* end ruin21.c */
