
/* 
 * LCAUView.h -- Interface file for the LCAUView class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to 
 * its fitness for any particular use.
 *
 */

#import <appkit/appkit.h>

@interface LCAUView:View {

	id		sButton, pButton;
	id		aRow, aRowR;
	id		anFact;
	id		anFreq;
	id		anRule;
	id		anVari;
	id		anWindow;
	id		genEv;
	id		histoGram;
	id		ascru,ruleSamples;
	id		wrule;
	id		dataList;
	id		rbutton,sbutton;
	id		ruleNumber;
	id		pslid;
	id		rijnps;

	id		tiDat;
	id		valBx;
	id		varText;
	id		varWindow;
	id		wholePanel;
	
/*  general evolution windows	*/

	id		ev1Window;
	id		ev2Window;
	id		ev3Window;

	id		menuCopy;
	id		menuPrint;

	id		theEvolView;
	id		thePlaidView;
	id		theShEvolView;
	id		theThEvolView;

	id		evolWindow;
	id		keyWindow;
	id		shEvolWindow;
	id		thEvolWindow;
	id		plaidWindow;
	
	id		baysRule;
	id		baysCoef;
	id		bernEdge;
	id		bernGens;
	id		bernProb;
	
	id		delegate;
	id		points;
	id		crossCursor;
	id		readOut;
	float		radius;
	BOOL		needsClearing;
}

- clearScreen:sender;
- drawEvolu:sender;
- drawPlEvol:sender;
- drawShEvol:sender;
- drawThEvol:sender;
- evWindow:sender;
- lifeRule:sender;
- printEvolu:sender;
- relatedRule:sender;
- showCursor:sender;
- showFrequencies:sender;
- showHistoGram:sender;
- showWrule:sender;
- showLine:sender;
- setRule:sender;
- makeline:sender;

- printPlain:sender;
- printShEvol:sender;
- printThEvol:sender;
- printPlEvol:sender;

- initFrame:(const NXRect *)frameRect;
- setDelegate:anObject;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- sizeTo:(NXCoord)width :(NXCoord)height;
- clear:sender;
- plot:sender;
- mouseDown:(NXEvent *)theEvent;
- registerPoint:(NXPoint *)aPoint;
- setRadius:(float)aFloat;
- (float)radius;
- read:(NXTypedStream *)stream;
- write:(NXTypedStream *)stream;
- awake;
- (const char *)inspectorName;

@end

/* end LCAUView.h */
