
/* nxlcau24.h			*/
/* header file for lcau24.c	*/
/* 12 May 1989			*/

# define COLGRAF		4  /* graph resolution			*/
# define T80X25			3  /* text resolution			*/
# define WHCYMAG		1  /* color quad for normal screen	*/
# define YELREGR		2  /* alternative color palette 	*/
# define CR		        5  /* cursor reference - row editor	*/
# define CM		        7  /* cursor reference - main menu	*/
# define CL		       11  /* cursor reference - line editor	*/
# define AL      	    16384  /* array length (screen width)	*/
# define SL		       40  /* short array length		*/
# define YL		      320  /* screen length (normally 320)	*/
# define RR			9  /* length of neighborhood = 2r+1	*/ 
# define KK	     		2  /* number of states per cell		*/
# define DN (KK*KK*KK*KK*KK*KK*KK*KK)  /* number of distinct nodes	*/
# define DS  KK*KK*KK*KK*KK*KK*KK*KK*KK  /* # distinct neighborhoods	*/
# define TS	    (RR*(KK-1)+1)  /* distinct sums w/totalistic rule	*/
# define SS  (KK*(RR-1)*(KK-1)+1)  /* distinct sums w/stotalistic rule	*/
# define PDN      4096	/* nodes in pair diagram = KK^4r	*/
# define SDN      4096	/* nodes in subset diagram = 2^(KK^2r)	*/
# define DDN	   256	/* maximum nodes any de Bruijn diagram	*/
# define QDN	  4096	/* maximum nodes 2-D de Bruijn diagram	*/
# define QWN	  1024  /* node list 2-D de Bruijn node & link  */
# define BD		       25  /* max number Bernstein coeffs	*/ 
# define BL		       26  /* no. Life 2g Bernstein coeffs	*/

# define RSYM		 4	/* number of rule symmetries = 2*k!	*/
# define WNML	       129	/* arry size for base 16 wolfram number */

# define CCY         11		/* circumference of max length cycle	*/
# define XCY	   2048		/* max number of cycles = KK^CCY	*/
# define XDB	    256		/* maximum nodes any de Bruijn diagram	*/

# define XAN	     52		/* nominal max number of ancestors/node	*/

# define K2     (KK*KK) 
# define K3     (KK*KK*KK) 
# define K4	(K2*K2)
# define K5	(K2*K3)
# define K6	(K3*K3)
# define K8	(K4*K4)
# define K9     (K8*KK)
# define AV	(KK*KK)


# define NX			5  /* number of demonstration rules	*/
# define NY		       14  /* number of REC demonstrations  	*/

# define CLEN		       76  /* rec source program length	 	*/
# define PLEN		   8*CLEN  /* rec object program length	 	*/
# define XLEN 128	/* buffer length for rec predefined */

# define DROWS		20	/* no of rows in demo menu       */
# define DCOLS		36	/* column for second col in d.m. */

# define RROWS		20	/* no of rows in demo menu       */
# define RCOLS		32	/* column for second col in d.m. */

# define HCH   32	/* characters+1 in help menus (text screen)    */
# define GCH   26	/* characters+1 in help menus (graphic screen) */

typedef union binrular {
		int one[KK*KK*KK*KK*KK*KK*KK*KK*KK]; 
		int nine[KK][KK][KK][KK][KK][KK][KK][KK][KK];
		} binrular;
typedef union ascrular {
		char one[KK*KK*KK*KK*KK*KK*KK*KK*KK]; 
		char nine[KK][KK][KK][KK][KK][KK][KK][KK][KK];
		} ascrular;

/* end nxlcau24.h */
