
/* nxlcauk6.c				*/
/* evolution programs appropriate to	*/
/* (k,6) Linear Cellular Automata	*/
/* Harold V. McIntosh, 15 April 1992	*/
/* 1 August 1994 - Adapted to NeXT	*/

/* ------------------------------------ */
/*    Copyright (C) 1992		*/
/*    Copyright (C) 1994		*/
/*    Harold V. McIntosh		*/
/* ------------------------------------ */

/* evolution for one generation */

onegen(j) int j; {
int      i, k, kk;
int      i0, i1, i2, i3, i4;
int      j0, j1, j2, j3, j4, j5, j6, j7, j8, j9, ja, jb;
long int ii;

switch (dn) {

case 1:
if (j>12) {
  j0=arr1[j-6];
  j1=arr1[j-5];
  j2=arr1[j-4];
  j3=arr1[j-3];
  j4=arr1[j-2];
  j5=arr1[j-1];
  arr2[0]=binrule[j0][j1][j2][j3][j4][j5][arr1[0]][arr1[1]][arr1[2]][arr1[3]][arr1[4]][arr1[5]][arr1[6]];
  arr2[1]=binrule[j1][j2][j3][j4][j5][arr1[0]][arr1[1]][arr1[2]][arr1[3]][arr1[4]][arr1[5]][arr1[6]][arr1[5]];
  arr2[2]=binrule[j2][j3][j4][j5][arr1[0]][arr1[1]][arr1[2]][arr1[3]][arr1[4]][arr1[5]][arr1[6]][arr1[7]][arr1[4]];
  arr2[3]=binrule[j3][j4][j5][arr1[0]][arr1[1]][arr1[2]][arr1[3]][arr1[4]][arr1[5]][arr1[6]][arr1[7]][arr1[8]][arr1[3]];
  arr2[4]=binrule[j4][j5][arr1[0]][arr1[1]][arr1[2]][arr1[3]][arr1[4]][arr1[5]][arr1[6]][arr1[7]][arr1[8]][arr1[9]][arr1[2]];
  arr2[5]=binrule[j5][arr1[0]][arr1[1]][arr1[2]][arr1[3]][arr1[4]][arr1[5]][arr1[6]][arr1[7]][arr1[8]][arr1[9]][arr1[10]][arr1[11]];
  for (i=6; i<j-6; i++) 
arr2[i]=binrule[arr1[i-6]][arr1[i-5]][arr1[i-4]][arr1[i-3]][arr1[i-2]][arr1[i-1]][arr1[i]][arr1[i+1]][arr1[i+2]][arr1[i+3]][arr1[i+4]][arr1[i+5]][arr1[i+6]];
  arr2[j-6]=binrule[arr1[j-12]][arr1[j-11]][arr1[j-10]][arr1[j-9]][arr1[j-8]][arr1[j-7]][j0][j1][j2][j3][j4][j5][arr1[0]];
  arr2[j-5]=binrule[arr1[j-11]][arr1[j-10]][arr1[j-9]][arr1[j-8]][arr1[j-7]][j0][j1][j2][j3][j4][j5][arr1[0]][arr1[1]];
  arr2[j-4]=binrule[arr1[j-10]][arr1[j-9]][arr1[j-8]][arr1[j-7]][j0][j1][j2][j3][j4][j5][arr1[0]][arr1[1]][arr1[2]];
  arr2[j-3]=binrule[arr1[j-9]][arr1[j-8]][arr1[j-7]][j0][j1][j2][j3][j4][j5][arr1[0]][arr1[1]][arr1[2]][arr1[3]];
  arr2[j-2]=binrule[arr1[j-8]][arr1[j-7]][j0][j1][j2][j3][j4][j5][arr1[0]][arr1[1]][arr1[2]][arr1[3]][arr1[4]];
  arr2[j-1]=binrule[arr1[j-7]][j0][j1][j2][j3][j4][j5][arr1[0]][arr1[1]][arr1[2]][arr1[3]][arr1[4]][arr1[5]];
} else if (j==12) {
  j0=arr1[0];
  j1=arr1[1];
  j2=arr1[2];
  j3=arr1[3];
  j4=arr1[4];
  j5=arr1[5];
  j6=arr1[6];
  j7=arr1[7];
  j8=arr1[8];
  j9=arr1[9];
  ja=arr1[10];
  jb=arr1[11];
    arr2[6]=binrule[j0][j1][j2][j3][j4][j5][j6][j7][j8][j9][ja][jb][j0];
    arr2[7]=binrule[j1][j2][j3][j4][j5][j6][j7][j8][j9][ja][jb][j0][j1];
    arr2[8]=binrule[j2][j3][j4][j5][j6][j7][j8][j9][ja][jb][j0][j1][j2];
    arr2[9]=binrule[j3][j4][j5][j6][j7][j8][j9][ja][jb][j0][j1][j2][j3];
    arr2[10]=binrule[j4][j5][j6][j7][j8][j9][ja][jb][j0][j1][j2][j3][j4];
    arr2[11]=binrule[j5][j6][j7][j8][j9][ja][jb][j0][j1][j2][j3][j4][j5];
    arr2[0]=binrule[j6][j7][j8][j9][ja][jb][j0][j1][j2][j3][j4][j5][j6];
    arr2[1]=binrule[j7][j8][j9][ja][jb][j0][j1][j2][j3][j4][j5][j6][j7];
    arr2[2]=binrule[j8][j9][ja][jb][j0][j1][j2][j3][j4][j5][j6][j7][j8];
    arr2[3]=binrule[j9][ja][jb][j0][j1][j2][j3][j4][j5][j6][j7][j8][j9];
    arr2[4]=binrule[ja][jb][j0][j1][j2][j3][j4][j5][j6][j7][j8][j9][ja];
    arr2[5]=binrule[jb][j0][j1][j2][j3][j4][j5][j6][j7][j8][j9][ja][jb];
} else if (j==11) {
  j0=arr1[0];
  j1=arr1[1];
  j2=arr1[2];
  j3=arr1[3];
  j4=arr1[4];
  j5=arr1[5];
  j6=arr1[6];
  j7=arr1[7];
  j8=arr1[8];
  j9=arr1[9];
  ja=arr1[10];
    arr2[6]=binrule[j0][j1][j2][j3][j4][j5][j6][j7][j8][j9][ja][j0][j1];
    arr2[7]=binrule[j1][j2][j3][j4][j5][j6][j7][j8][j9][ja][j0][j1][j2];
    arr2[8]=binrule[j2][j3][j4][j5][j6][j7][j8][j9][ja][j0][j1][j2][j3];
    arr2[9]=binrule[j3][j4][j5][j6][j7][j8][j9][ja][j0][j1][j2][j3][j4];
    arr2[10]=binrule[j4][j5][j6][j7][j8][j9][ja][j0][j1][j2][j3][j4][j5];
    arr2[0]=binrule[j5][j6][j7][j8][j9][ja][j0][j1][j2][j3][j4][j5][j6];
    arr2[1]=binrule[j6][j7][j8][j9][ja][j0][j1][j2][j3][j4][j5][j6][j7];
    arr2[2]=binrule[j7][j8][j9][ja][j0][j1][j2][j3][j4][j5][j6][j7][j8];
    arr2[3]=binrule[j8][j9][ja][j0][j1][j2][j3][j4][j5][j6][j7][j8][j9];
    arr2[4]=binrule[j9][ja][j0][j1][j2][j3][j4][j5][j6][j7][j8][j9][ja];
    arr2[5]=binrule[ja][j0][j1][j2][j3][j4][j5][j6][j7][j8][j9][ja][j0];
} else if (j==10) {
  j0=arr1[0];
  j1=arr1[1];
  j2=arr1[2];
  j3=arr1[3];
  j4=arr1[4];
  j5=arr1[5];
  j6=arr1[6];
  j7=arr1[7];
  j8=arr1[8];
  j9=arr1[9];
    arr2[6]=binrule[j0][j1][j2][j3][j4][j5][j6][j7][j8][j9][j0][j1][j2];
    arr2[7]=binrule[j1][j2][j3][j4][j5][j6][j7][j8][j9][j0][j1][j2][j3];
    arr2[8]=binrule[j2][j3][j4][j5][j6][j7][j8][j9][j0][j1][j2][j3][j4];
    arr2[9]=binrule[j3][j4][j5][j6][j7][j8][j9][j0][j1][j2][j3][j4][j5];
    arr2[0]=binrule[j4][j5][j6][j7][j8][j9][j0][j1][j2][j3][j4][j5][j6];
    arr2[1]=binrule[j5][j6][j7][j8][j9][j0][j1][j2][j3][j4][j5][j6][j7];
    arr2[2]=binrule[j6][j7][j8][j9][j0][j1][j2][j3][j4][j5][j6][j7][j8];
    arr2[3]=binrule[j7][j8][j9][j0][j1][j2][j3][j4][j5][j6][j7][j8][j9];
    arr2[4]=binrule[j8][j9][j0][j1][j2][j3][j4][j5][j6][j7][j8][j9][j0];
    arr2[5]=binrule[j9][j0][j1][j2][j3][j4][j5][j6][j7][j8][j9][j0][j1];
} else if (j==9) {
  j0=arr1[0];
  j1=arr1[1];
  j2=arr1[2];
  j3=arr1[3];
  j4=arr1[4];
  j5=arr1[5];
  j6=arr1[6];
  j7=arr1[7];
  j8=arr1[8];
    arr2[6]=binrule[j0][j1][j2][j3][j4][j5][j6][j7][j8][j0][j1][j2][j3];
    arr2[7]=binrule[j1][j2][j3][j4][j5][j6][j7][j8][j0][j1][j2][j3][j4];
    arr2[8]=binrule[j2][j3][j4][j5][j6][j7][j8][j0][j1][j2][j3][j4][j5];
    arr2[0]=binrule[j3][j4][j5][j6][j7][j8][j0][j1][j2][j3][j4][j5][j6];
    arr2[1]=binrule[j4][j5][j6][j7][j8][j0][j1][j2][j3][j4][j5][j6][j7];
    arr2[2]=binrule[j5][j6][j7][j8][j0][j1][j2][j3][j4][j5][j6][j7][j8];
    arr2[3]=binrule[j6][j7][j8][j0][j1][j2][j3][j4][j5][j6][j7][j8][j0];
    arr2[4]=binrule[j7][j8][j0][j1][j2][j3][j4][j5][j6][j7][j8][j0][j1];
    arr2[5]=binrule[j8][j0][j1][j2][j3][j4][j5][j6][j7][j8][j0][j1][j2];
} else if (j==8) {
  j0=arr1[0];
  j1=arr1[1];
  j2=arr1[2];
  j3=arr1[3];
  j4=arr1[4];
  j5=arr1[5];
  j6=arr1[6];
  j7=arr1[7];
    arr2[6]=binrule[j0][j1][j2][j3][j4][j5][j6][j7][j0][j1][j2][j3][j4];
    arr2[7]=binrule[j1][j2][j3][j4][j5][j6][j7][j0][j1][j2][j3][j4][j5];
    arr2[0]=binrule[j2][j3][j4][j5][j6][j7][j0][j1][j2][j3][j4][j5][j6];
    arr2[1]=binrule[j3][j4][j5][j6][j7][j0][j1][j2][j3][j4][j5][j6][j7];
    arr2[2]=binrule[j4][j5][j6][j7][j0][j1][j2][j3][j4][j5][j6][j7][j0];
    arr2[3]=binrule[j5][j6][j7][j0][j1][j2][j3][j4][j5][j6][j7][j0][j1];
    arr2[4]=binrule[j6][j7][j0][j1][j2][j3][j4][j5][j6][j7][j0][j1][j2];
    arr2[5]=binrule[j7][j0][j1][j2][j3][j4][j5][j6][j7][j0][j1][j2][j3];
} else if (j==7) {
  j0=arr1[0];
  j1=arr1[1];
  j2=arr1[2];
  j3=arr1[3];
  j4=arr1[4];
  j5=arr1[5];
  j6=arr1[6];
    arr2[6]=binrule[j0][j1][j2][j3][j4][j5][j6][j0][j1][j2][j3][j4][j5];
    arr2[0]=binrule[j1][j2][j3][j4][j5][j6][j0][j1][j2][j3][j4][j5][j6];
    arr2[1]=binrule[j2][j3][j4][j5][j6][j0][j1][j2][j3][j4][j5][j6][j0];
    arr2[2]=binrule[j3][j4][j5][j6][j0][j1][j2][j3][j4][j5][j6][j0][j1];
    arr2[3]=binrule[j4][j5][j6][j0][j1][j2][j3][j4][j5][j6][j0][j1][j2];
    arr2[4]=binrule[j5][j6][j0][j1][j2][j3][j4][j5][j6][j0][j1][j2][j3];
    arr2[5]=binrule[j6][j0][j1][j2][j3][j4][j5][j6][j0][j1][j2][j3][j4];
} else if (j==6) {
  j0=arr1[0];
  j1=arr1[1];
  j2=arr1[2];
  j3=arr1[3];
  j4=arr1[4];
  j5=arr1[5];
    arr2[0]=binrule[j0][j1][j2][j3][j4][j5][j0][j1][j2][j3][j4][j5][j0];
    arr2[1]=binrule[j1][j2][j3][j4][j5][j0][j1][j2][j3][j4][j5][j0][j1];
    arr2[2]=binrule[j2][j3][j4][j5][j0][j1][j2][j3][j4][j5][j0][j1][j2];
    arr2[3]=binrule[j3][j4][j5][j0][j1][j2][j3][j4][j5][j0][j1][j2][j3];
    arr2[4]=binrule[j4][j5][j0][j1][j2][j3][j4][j5][j0][j1][j2][j3][j4];
    arr2[5]=binrule[j5][j0][j1][j2][j3][j4][j5][j0][j1][j2][j3][j4][j5];
} else if (j==5) {
  j0=arr1[0];
  j1=arr1[1];
  j2=arr1[2];
  j3=arr1[3];
  j4=arr1[4];
    arr2[1]=binrule[j0][j1][j2][j3][j4][j0][j1][j2][j3][j4][j0][j1][j2];
    arr2[2]=binrule[j1][j2][j3][j4][j0][j1][j2][j3][j4][j0][j1][j2][j3];
    arr2[3]=binrule[j2][j3][j4][j0][j1][j2][j3][j4][j0][j1][j2][j3][j4];
    arr2[4]=binrule[j3][j4][j0][j1][j2][j3][j4][j0][j1][j2][j3][j4][j0];
    arr2[0]=binrule[j4][j0][j1][j2][j3][j4][j0][j1][j2][j3][j4][j0][j1];
} else if (j==4) {
  j0=arr1[0];
  j1=arr1[1];
  j2=arr1[2];
  j3=arr1[3];
    arr2[2]=binrule[j0][j1][j2][j3][j0][j1][j2][j3][j0][j1][j2][j3][j0];
    arr2[3]=binrule[j1][j2][j3][j0][j1][j2][j3][j0][j1][j2][j3][j0][j1];
    arr2[0]=binrule[j2][j3][j0][j1][j2][j3][j0][j1][j2][j3][j0][j1][j2];
    arr2[1]=binrule[j3][j0][j1][j2][j3][j0][j1][j2][j3][j0][j1][j2][j3];
} else if (j==3) {
  j0=arr1[0];
  j1=arr1[1];
  j2=arr1[2];
    arr2[0]=binrule[j0][j1][j2][j0][j1][j2][j0][j1][j2][j0][j1][j2][j0];
    arr2[1]=binrule[j1][j2][j0][j1][j2][j0][j1][j2][j0][j1][j2][j0][j1];
    arr2[2]=binrule[j2][j0][j1][j2][j0][j1][j2][j0][j1][j2][j0][j1][j2];
} else if (j==2) {
  j0=arr1[0];
  j1=arr1[1];
    arr2[0]=binrule[j0][j1][j0][j1][j0][j1][j0][j1][j0][j1][j0][j1][j0];
    arr2[1]=binrule[j1][j0][j1][j0][j1][j0][j1][j0][j1][j0][j1][j0][j1];
} else if (j==1) {
  j0=arr1[0];
    arr2[0]=binrule[j0][j0][j0][j0][j0][j0][j0][j0][j0][j0][j0][j0][j0];
}
if (co==1) for (ii=0; ii<j; ii++) arr1[(int)ii]=arr2[(int)(ii)];
if (co==0) for (ii=0; ii<j; ii++) arr1[(int)ii]=arr2[(int)((7*ii)%j)];
if (co==2) for (ii=0; ii<j; ii+=2) {arr1[(int)ii]=arr2[(int)((7*ii)%j)];
				 arr1[(int)ii+1]=arr2[(int)((7*ii+1)%j)];}
if (co==3) for (ii=0; ii<j; ii+=3) {arr1[(int)ii]=arr2[(int)((7*ii)%j)];
				 arr1[(int)ii+1]=arr2[(int)((7*ii+1)%j)];
				 arr1[(int)ii+2]=arr2[(int)((7*ii+2)%j)];}
if (co==4) for (ii=0; ii<j; ii+=4) {arr1[(int)ii]=arr2[(int)((7*ii)%j)];
				 arr1[(int)ii+1]=arr2[(int)((7*ii+1)%j)];
				 arr1[(int)ii+2]=arr2[(int)((7*ii+2)%j)];
				 arr1[(int)ii+3]=arr2[(int)((7*ii+3)%j)];}

if (co==5) {for (ii=0; ii<j; ii+=2) {arr1[(int)ii]=arr2[(int)((11*ii)%j)];
				 arr1[(int)ii+1]=arr2[(int)((11*ii+1)%j)];}
	    for (ii=0; ii<j; ii+=8) {
		k=arr1[(int)ii];
		arr1[(int)ii]=arr1[(int)((ii+2)%j)];
		arr1[(int)((ii+2)%j)]=k;
		k=arr1[(int)((ii+1)%j)];
		arr1[(int)((ii+1)%j)]=arr1[(int)((ii+4)%j)];
		arr1[(int)((ii+4)%j)]=k;
		k=arr1[(int)((ii+3)%j)];
		arr1[(int)((ii+3)%j)]=arr1[(int)((ii+5)%j)];
		arr1[(int)((ii+5)%j)]=k;
                }
	    }
if (co==6) {for (ii=0; ii<j; ii+=2) {arr1[(int)ii]=arr2[(int)((11*ii)%j)];
				 arr1[(int)ii+1]=arr2[(int)((11*ii+1)%j)];}
	    for (ii=0; ii<j; ii+=16) {
		k=arr1[(int)ii];
		arr1[(int)ii]=arr1[(int)((ii+2)%j)];
		arr1[(int)((ii+2)%j)]=k;
		k=arr1[(int)((ii+1)%j)];
		arr1[(int)((ii+1)%j)]=arr1[(int)((ii+4)%j)];
		arr1[(int)((ii+4)%j)]=k;
		k=arr1[(int)((ii+3)%j)];
		arr1[(int)((ii+3)%j)]=arr1[(int)((ii+5)%j)];
		arr1[(int)((ii+5)%j)]=k;

		k=arr1[(int)((ii+8)%j)];
		arr1[(int)((ii+8)%j)]=arr1[(int)((ii+10)%j)];
		arr1[(int)((ii+10)%j)]=k;
		k=arr1[(int)((ii+9)%j)];
		arr1[(int)((ii+9)%j)]=arr1[(int)((ii+15)%j)];
		arr1[(int)((ii+15)%j)]=k;
		k=arr1[(int)((ii+11)%j)];
		arr1[(int)((ii+11)%j)]=arr1[(int)((ii+13)%j)];
		arr1[(int)((ii+13)%j)]=k;
		k=arr1[(int)((ii+12)%j)];
		arr1[(int)((ii+12)%j)]=arr1[(int)((ii+14)%j)];
		arr1[(int)((ii+14)%j)]=k;
		}
	    } break;

case 5: if (j<16384) break;
	  for (i0=0; i0<8; i0++) for (i1=0; i1<8; i1++) 
	  for (i2=0; i2<8; i2++) for (i3=0; i3<8; i3++) 
	  for (i4=0; i4<4; i4++)
	    arr2[ix5(i0,i1,i2,i3,i4)]=binrule
	      [arr1[ix5(i0-1,i1,i2,i3,i4)]][arr1[ix5(i0+1,i1,i2,i3,i4)]]
	      [arr1[ix5(i0,i1-1,i2,i3,i4)]][arr1[ix5(i0,i1+1,i2,i3,i4)]]
	      [arr1[ix5(i0,i1,i2-1,i3,i4)]][arr1[ix5(i0,i1,i2+1,i3,i4)]]
	      [arr1[ix5(i0,i1,i2,i3-1,i4)]][arr1[ix5(i0,i1,i2,i3+1,i4)]]
	      [arr1[ix5(i0,i1,i2,i3,i4-1)]][arr1[ix5(i0,i1,i2,i3,i4+1)]]
	      [arr1[ix5(i0,i1,i2,i3,i4)]];
	  for (i=0; i<16384; i++) arr1[i]=arr2[i];
	    break;

default: break;}
}

/* -------------------------------------------------------------- */

/* index five dimensions */
int ix5(i,j,k,l,m) int i, j, k, l, m; {
return (8+i)%8+ 8*( (8+j)%8+ 8*( (8+k)%8+ 8*( (8+l)%8+ 8*( (4+m)%4 ))));}

/* clear neighborhood sums to zeroes */
nhzer() {int i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, ia, ib, ic;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
for (i7=0; i7<KK; i7++)
for (i8=0; i8<KK; i8++)
for (i9=0; i9<KK; i9++)
for (ia=0; ia<KK; ia++)
for (ib=0; ib<KK; ib++)
for (ic=0; ic<KK; ic++)
  nhsum[i0][i1][i2][i3][i4][i5][i6][i7][i8][i9][ia][ib][ic]=0;
}

/* clear state sums to zeroes */
stzer() {int i0; for (i0=0; i0<KK; i0++) stsum[i0]=0;}

/* end nxlcauk6.c */
