
/* lcaukr.c				*/
/* generic programs appropriate to	*/
/* all (k,r) Linear Cellular Automata	*/
/* Harold V. McIntosh, 15 April 1992	*/

/*    Copyright (C) 1992		*/
/*    Harold V. McIntosh		*/

/* ------------------------------------ */

/* index two dimensions */
int ix2(i,j) int i, j; 
{return (128+i)%128+128*((128+j)%128);}

/* index three dimensions */
int ix3(i,j,k) int i, j, k; 
{return (32+i)%32+ 32*((32+j)%32+ 32*((16+k)%16 ));}

/* index four dimensions */
int ix4(i,j,k,l) int i, j, k, l; {
return (16+i)%16+ 16*( (8+j)%8+ 8*( (16+k)%16+ 16*( (8+l)%8 )));}

txtmode() {videomode(T80X25); rmenu(); lmenu();}
grfmode() {videomode(COLGRAF);}

/* display semitotalistic rule number by sum */
sscrrul(j) int j; {int i; for (i=0; i<TS-1; i++) videoputc(strule[j][i],1); }

/* display totalistic rule number by sum */
tscrrul() {int i; for (i=0; i<TS; i++) videoputc(ttrule[i],1); }

/* write a string in graphics mode */
scrstr(s) char *s; {}

/* place time and date on screen */ 
tidat() {long cl[1]; char *ctime(); time(cl); printf("%26s",ctime(cl));}

/* keyboard status */
int kbdst() {}

/* direct keyboard input, no echo */
kbdin() {}

/* turn ASCII character into hexadecimal value */
int nibbl(c) int c; {
  if (c>='0'&&c<='9') return (c-'0');
  if (c>='a'&&c<='f') return (c-'a'+10);
  if (c>='A'&&c<='F') return (c-'A'+10);
  return 0;
}

/* turn a nibble into an ASCII character */
int nibasc(i) int i; {if (i<10) return '0'+i; else return 'A'+i-10;}

/* read number from keyboard */
int numin(n) int n; {}

/* end nxlcaukr.c */
