
# import  "nxlcau26.h"
# import  <dpsclient/psops.h>
# import  <appkit/graphics.h>

# define GH    (DS/KK)	/* DS/KK= half number of neighborhoods	*/
# define QS	   128  /* number of symmetry classes		*/
# define NF	    50	/* lines in live frequency graph	*/
# define NG	    10	/* number of Golay Classes		*/

char    golRule22[KK*NG];	/* evolutionary rule       */
int     li, lj;		/* cursor in cell array    */
double  bp[TS];		/* Bernstein coefficients  */

extern char   ascrule[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];

mainsquar() {}	   /* end main */

/* graph statistics of rule usage */
/* beware limited count capacity  */
/* large counts look negative     */
arrrstat() {int i, j, m, n; double s, t;
for (i=0, s=0.0; i<QS; i++) s+=(double)rus22[i];
if  (s<1.0) {for (i=0; i<QS; i++) rus22[i]=0; return;};
for (i=0; i<QS; i++) {
  t=333.3*(((double)rus22[i])/s);	/* full scale = 1/10 population */
  if (t>=32000.0) t=50.0;	/* larger looks negative */
  n=(int)t;
  arrsdot(i,33,0);
  m=33; if (n>33) {n=33; m=34;};
  if (n>0) for (j=0; j<n; j++) arrsdot(i,j,1);
  for (j=n; j<m; j++) arrsdot(i,j,2);
  rus22[i]=0;
  }
}

/* graph fraction of live cells */
/* y = column for dot */
/* n = value to be graphed */
arrlstat(y,n) int y, n; {int i, k;
  k=(int)(100.0*(((double)(n))/((double)(AL*AL))));
  if (k<=0) k=1; if (k>=100) k=99;
  for (i=0; i<k; i++) ldot(i,y,1);
  for (i=k; i<101; i++) ldot(i,y,2);
  for (i=0; i<101; i++) ldot(i,y+1,0);
  for (i=0; i<101; i+=10) ldot(i,y+1,3);
}

/* generate the semitotalistic code table */
stotta() {int i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, ia, ib, ic;
  for (i6=0; i6<KK; i6++)
  for (i5=0; i5<KK; i5++)
  for (i4=0; i4<KK; i4++)
  for (i3=0; i3<KK; i3++)
  for (i2=0; i2<KK; i2++)
  for (i1=0; i1<KK; i1++)
  for (i0=0; i0<KK; i0++)
    stc22[i0+KK*(i1+KK*(i2+KK*(i3+KK*(i4+KK*(i5+KK*i6)))))] = 
	i0+i1+i2+i3+i4+i5+12*ic;
}

/* generate the Golay code table */
arrgolta() {
int i, j, k;
int i0, i1, i2, i3;
int arrbinq();
k=0;
for (i3=0; i3<KK; i3++)
for (i2=0; i2<KK; i2++)
for (i1=0; i1<KK; i1++)
for (i0=0; i0<KK; i0++) {
  i=arrbinq(i0,i1,i2,i3);
  j=arrbinq(i1,i2,i3,i0);
  if (j<i) i=j;
  j=arrbinq(i2,i3,i0,i1);
  if (j<i) i=j;
  j=arrbinq(i3,i0,i1,i2);
  if (j<i) i=j;
  j=arrbinq(i0,i3,i2,i1);
  if (j<i) i=j;
  j=arrbinq(i3,i2,i1,i0);
  if (j<i) i=j;
  j=arrbinq(i2,i1,i0,i3);
  if (j<i) i=j;
  j=arrbinq(i1,i0,i3,i2);
  if (j<i) i=j;
  j=arrbinq(i0,i1,i2,i3);
  if (i==j) {gc22[i]=k; k++;} else {gc22[j]=gc22[i];};
  }
/* printf("no. cl. = %3d",k); */
}

/* calculate binary equivalent */
int arrbinq(i0,i1,i2,i3) int i0, i1, i2, i3; {return i0+KK*(i1+KK*(i2+KK*i3));}

/* calculate Golay class of a cell */
/* no check is made that cell isn't at array edge */
int arrgolcl(i0,i1,arr1) int  i0, i1, arr1[AL][AL]; {int gn;
gn=arr1[i0-1][i1];
gn=KK*gn+arr1[i0][i1-1];
gn=KK*gn+arr1[i0+1][i1];
gn=KK*gn+arr1[i0][i1+1];
if (arr1[i0][i1]==1) gn+=GH;
gn=gc22[gn];
return gn;
}

/* plot self-consistent probability graph */
bppanel() {arrburnc(); arrgfram(100); arrgdiag(100); barrgraf(RR,100);}

/* generate Bernstein coefficients */
arrburnc() {int i;
  for (i=0; i<RR+1; i++) bp[i]=0.0;
  if (golRule22[0]=='1') bp[0]+=1.0;
  if (golRule22[1]=='1') bp[1]+=4.0;
  if (golRule22[2]=='1') bp[2]+=4.0;
  if (golRule22[3]=='1') bp[2]+=2.0;
  if (golRule22[4]=='1') bp[3]+=4.0;
  if (golRule22[5]=='1') bp[4]+=1.0;
  if (golRule22[6]=='1') bp[1]+=1.0;
  if (golRule22[7]=='1') bp[2]+=4.0;
  if (golRule22[8]=='1') bp[3]+=4.0;
  if (golRule22[9]=='1') bp[3]+=2.0;
  if (golRule22[10]=='1') bp[4]+=4.0;
  if (golRule22[11]=='1') bp[5]+=1.0;
}

/* ldot(i,j,l) - place dot on live probability  screen at (i,j) in color l */
ldot(i,j,l) int i, j, l; {videodot(90-NF+j,i,l);}

/* arrsdot(i,j,l) - place dot on statistics screen at (i,j) in color l */
arrsdot(i,j,l) int i, j, l; {videodot(199-10-j,70+5*i,l);}

/* clear the cell array */
arrzarry(arr1) int  arr1[AL][AL]; {int i0, i1;
for (i0=0; i0<AL; i0++) for (i1=0; i1<AL; i1++) arr1[i0][i1]=0;
}

/* display rule menu */
arrmenu() {}

/* display rule number by sum in color */
arrscrrul(y,x) int x, y; {int i, n;
n=QS;
videocursor(0,y,x);
//   arrscrstr("  ");
  for (i=0;   i<n;   i++) arrresch(i);
videocursor(0,y,x);
}

/* display rule number as a hexadecimal */
harrscrrul() {int i, k;
  videocursor(0,0,0);
  printf("    ");
  for (i=0,  k=0; i<12;  i++) k=KK*k+sqrule22[i]-'0';
  printf("%3.3X",k);
  videocursor(0,0,0);
  }

/* display Wolfram rule number of cross section */
warrscrrul() {int i;
  i=sqrule22[11]-'0';
  i=KK*i+sqrule22[10]-'0';
  i=KK*i+sqrule22[3]-'0';
  i=KK*i+sqrule22[1] -'0';
  i=KK*i+sqrule22[10]-'0';
  i=KK*i+sqrule22[9]-'0';
  i=KK*i+sqrule22[1] -'0';
  i=KK*i+sqrule22[0] -'0';
  videocursor(0,0,32);
  printf("     ");
  videocursor(0,0,32);
  printf("[%2d]",i);
  videocursor(0,0,0);
  }

/* edit the rule */
arredrule() {char c; int i;
  i=0;
  while (0<1) {
//    videocursor(0,TRR,TRC+i+2);
    videoputc(sqrule22[i],3);
//    videocursor(0,TRR,TRC+i+2);
    c=kbdin();
      if (c=='\015') break;				/* carriage return */
      switch (c) {
        case '0': case '1': 				/* state = 0,1 */
          sqrule22[i]=c;
	  arrresch(i);
          i++; if (i==QS) i=0;
	  break;
        case ' ': case '\315':				/* space = advance */
	  arrresch(i);
          i++; if (i==QS) i=0;
	  break;
        case '\010': case '\313':			/* backspace */
	  arrresch(i);
          if (i>0) i--;
	  break;
	case '<':					/* cursor to front */
	  arrresch(i);
	  i=0;
	  break;
	case '>':					/* cursor to end */
	  arrresch(i);
	  i=QS-1;
	  break;
	case '\013': case '\310':			/* up arrow */
	  qarule22[i]='+';
	  arrresch(i);
          i++; if (i==QS) i=0;
	  break;
	case '\012': case '\320':			/* down arrow */
	  qarule22[i]=' ';
	  arrresch(i);
          i++; if (i==QS) i=0;
	  break;
	default:
	  break;
          };
    };
}

/* restore character in edrule */
arrresch(i) int i; {videoputc(sqrule22[i],(qarule22[i]==' ')?1:2);}

/* edit the plane of cells */
arredline(arr1) int arr1[AL][AL]; {
char c;
int  i, j, k, arr2[AL][AL], arrgolcl();

for (i=0; i<AL; i++) for (j=0; j<AL; j++) arr2[i][j]=0;

videoscroll(19,0,24,25,0,0);
videocursor(0,19,0);
// arrscrstr("insert states with 0,1,.");
videocursor(0,20,0);
// arrscrstr("move cursor using arrows");
videocursor(0,21,0);
// arrscrstr("NSEW R CGO fgmxz *<>^_");
videocursor(0,22,0);
// arrscrstr("carriage return exits");

while (0<1) {
  arradot(li,lj,3);
  videocursor(0,0,1);
  videoputc('?',1);
  c=kbdin();
  videocursor(0,0,1);
  videoputc(c,1);
  if (c == '\015') break;
  switch (c) {
    case '0': case '1':	case '.':	/* enter state */
      if (c=='.') c='1';
      i=c-'0';
      arr1[li][lj]=i;
      arradot(li,lj,i);
      break;
    case '\012': case '\320':		/* down    */
      arradot(li,lj,arr1[li][lj]);
      lj++; if (lj==AL) lj=0;
      break;
    case '\013': case '\310':		/* up      */
      arradot(li,lj,arr1[li][lj]);
      if (lj==0) lj=AL; lj--;
      break;
    case '\014': case '\315': case ' ':	/* forward */
      arradot(li,lj,arr1[li][lj]);
      li++; if (li==AL) li=0;
      break;
    case '\010': case '\313':		/* back    */
      arradot(li,lj,arr1[li][lj]);
      if (li==0) li=AL; li--;
      break;
    case '<':				/* left margin  */
      arradot(li,lj,arr1[li][lj]);
      li=0;
      break;
    case '>':				/* right margin */
      arradot(li,lj,arr1[li][lj]);
      li=AL-1;
      break;
    case '^':				/* top margin  */
      arradot(li,lj,arr1[li][lj]);
      lj=0;
      break;
   case '_':				/* bottom margin  */
      arradot(li,lj,arr1[li][lj]);
      lj=AL-1;
      break;
   case '*':				/* bottom margin  */
      arradot(li,lj,arr1[li][lj]);
      li=AL/2; 
      lj=AL/2;
      break;
     case 'f':				/* generate a frame */
//      arrframe (2);
      break;
    case 'g':				/* one cycle of evolution */
//      arrframe (1);
//      cuonegen(arr1);
      arrscreen(arr1);
      break;
    case 'm':				/* mark neighborhood */
      qarule22[arrgolcl(li,lj,arr1)]='+';
//      arrscrrul(TRR,TRC);
      break;
    case 'M':				/* mark neighborhood over a region */
      if (li<10||li>AL-11) break;
      if (lj<10||lj>AL-11) break;
      for (i=li-10; i<li+10; i++) {
      for (j=lj-10; j<lj+10; j++) {
        qarule22[arrgolcl(i,j,arr1)]='+';
        };};
//      arrscrrul(TRR,TRC);
      break;
    case 'x':				/* uncomitted transitions */
      for (k=0; k<QS; k++) qarule22[k]=' ';
//      videocursor(0,TRR,TRC);
//      arrscrrul(TRR,TRC);
      break;
    case 'z':				/* clear array  */
      arrzarry(arr1);
      arrscreen(arr1);
      break;
    case 'N':				/* rotate array up */
      for (i=0; i<AL; i++) {
        k=arr1[i][0]; 
        for (j=1; j<AL; j++) arr1[i][j-1]=arr1[i][j];
        arr1[i][AL-1]=k;
	};
      if (lj==0) lj=AL; lj--;
      arrscreen(arr1);
      break;
    case 'S':				/* rotate array down */
      for (i=0; i<AL; i++) {
        k=arr1[i][AL-1];
        for (j=1; j<AL; j++) arr1[i][AL-j]=arr1[i][AL-j-1];
        arr1[i][0]=k;
	};
      lj++; if (lj==AL) lj=0;
      arrscreen(arr1);
      break;
    case 'E':				/* rotate array right */
      for (j=0; j<AL; j++) {
        k=arr1[AL-1][j];
        for (i=1; i<AL; i++) arr1[AL-i][j]=arr1[AL-i-1][j];
        arr1[0][j]=k;
	};
      li++; if (li==AL) li=0;
      arrscreen(arr1);
      break;
    case 'W':				/* rotate array left */
      for (j=0; j<AL; j++) {
        k=arr1[0][j];
        for (i=1; i<AL; i++) arr1[i-1][j]=arr1[i][j];
	arr1[AL-1][j]=k;
	};
      if (li==0) li=AL; li--;
      arrscreen(arr1);
      break;
    case 'R':				/* reflect array in diagonal */
      for (j=1; j<AL; j++) {
      for (i=0; i<j;  i++) {
        k=arr1[i][j];
	arr1[i][j]=arr1[j][i];
        arr1[j][i]=k;
        };};
      k=li; li=lj; lj=k;
      arrscreen(arr1);
      break;
    case 'C':				/* save cell array */
      for (j=0; j<AL; j++) {
      for (i=0; i<AL; i++) {
	arr2[i][j]=arr1[i][j];
	};};
      break;
    case 'G':				/* recover saved cell array */
      for (j=0; j<AL; j++) {
      for (i=0; i<AL; i++) {
	arr1[i][j]=arr2[i][j];
	};};
      arrscreen(arr1);
      break;
    case 'O':				/* or saved cell array */
      for (j=0; j<AL; j++) {
      for (i=0; i<AL; i++) {
	arr1[i][j]|=arr2[i][j];
	};};
      arrscreen(arr1);
      break;
    default:
      break;
      };				/* end switch */
  };					/* end while */
arradot(li,lj,arr1[li][lj]);
videoscroll(19,0,24,25,0,0);
videocursor(0,0,1);
videoputc(' ',1);
}				        /* end aredline */

/* generate random cells in arr1 */
arrranarr(arr1) int  arr1[AL][AL]; {int i0, i1, i;
for (i=0, i0=0; i0<AL; i0++) for (i1=0; i1<AL; i1++) arr1[i0][i1]=random()%KK;
}

/* generate random cells in the center of arr1 */
arrrancen(arr1) int  arr1[AL][AL]; {int i0, i1, ia, ib;
  for (i0=0; i0<AL; i0++) 
  for (i1=0; i1<AL; i1++) arr1[i0][i1]=0;
  ia=AL/3; ib=2*(AL/3);
  for (i0=ia; i0<ib; i0++)
  for (i1=ia; i1<ib; i1++) arr1[i0][i1]=random()%KK;
}

/* generate a random rule */
arrranrul() {int i; for (i=0; i<QS; i++) sqrule22[i]=random()%KK+'0';}

/* write a string in graphics mode */
arrrscrstr(s) char *s; {for (; *s != '\0'; s++) videoputc(*s,1); }

// # include "nxruin22.c"

/* end nxsqar22.c */
